﻿$(document).ready(function () {
    var pId = $('#projectId').text();

    var projectHostViewDatatable = $('#projectHostViewDatatable').DataTable({
        "language": {
            "processing": "Loading data...",
        },
        "stateSave": false,
        "pageLength": 25,
        "lengthMenu": [5, 10, 25, 50, 100, 200, 500],
        "select": true,
        "searching": false,
        "scrollX": true,
        "autoWidth": true,
        "processing": true,
        "serverSide": false,
        "filter": true,
        "columnDefs": [
            {
                "targets": [0], "data": null,
                render: function (data, type, row, meta) {
                    return `<a href="/Hosts/View?id=` + row[1] + `" type="button" class="btn btn-secondary btn-sm" title="View host"><span class="far fa-eye"></span></a>`;
                }
            },
            { "targets": [1], "visible": false, "orderable": false, "searchable": false, },
            { "targets": [2], "orderable": true, "searchable": false, },
            { "targets": [3], "orderable": true, "searchable": false, },
            { "targets": [4], "orderable": true, "searchable": false, },
            { "targets": [5], "orderable": true, "searchable": false, },
            { "targets": [6], "orderable": true, "searchable": false, },
            { "targets": [7], "orderable": true, "searchable": false, },
            { "targets": [8], "orderable": true, "searchable": false, }
        ],
    });

    /*
     * Show/hide columns
     * */
    $('button.toggle-vis').on('click', function (e) {
        e.preventDefault();

        // Get the column API object
        var column = projectHostViewDatatable.column($(this).attr('data-column'));

        // Toggle the visibility
        column.visible(!column.visible());
    });

    $('input.toogle-column-visibility').on('click', function (e) {
        // Get the column API object
        var column = projectHostViewDatatable.column($(this).attr('data-column'));

        // Toggle the visibility
        column.visible(!column.visible());
    });

    $('button.toogle-column-visibility-select-special').on('click', function (e) {
        if (this.id === "customSwitchShowAll") {
            showAllColumns();
        }
        else if (this.id === "customSwitchHideAll") {
            hideAllColumns();
        }
    });

    /*
     * Set correct state on visibility switches when modul loads
     * */
    $('a.show-hide-columns').on('click', function (e) {
        setCorrectSwitchStates();
    });

    function setCorrectSwitchStates() {
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");

        for (let i = 0; i < allCheckboxes.length; i++) {
            var column = projectHostViewDatatable.column($(allCheckboxes[i]).attr('data-column'));
            var isVisible = column.visible();
            if (isVisible == true) {
                allCheckboxes[i].checked = true;
            }
            else {
                allCheckboxes[i].checked = false;
            }
        }
    }

    function showAllColumns() {
        projectHostViewDatatable.columns().visible(true);
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");
        projectHostViewDatatable.columns([1]).visible(false); //Exceptions, always hide this column
        for (let i = 0; i < allCheckboxes.length; i++) {
            allCheckboxes[i].checked = true;
        }
    }

    function hideAllColumns() {
        projectHostViewDatatable.columns().visible(false);
        projectHostViewDatatable.columns([0]).visible(true); //Exceptions, never hide this column
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");

        for (let i = 0; i < allCheckboxes.length; i++) {
            allCheckboxes[i].checked = false;
        }
    }
});