﻿$('#files').on('change',
    function () {
        //replace the "Choose a file" label
        $(document.getElementById("UploadBtn")).removeClass("disabled");

        if (this.files.length > 1) {
            $(this).next('.custom-file-label').html(this.files.length + " files selected");
        }
        else {
            //get the file name
            var fileName = $(this).val().replace(/C:\\fakepath\\/, '');
            $(this).next('.custom-file-label').html(fileName);
        }
    })

function uploadFiles(inputId) {
    var t = $("input[name='__RequestVerificationToken']").val();
    var input = document.getElementById(inputId);
    var files = input.files;
    var formData = new FormData();
    var delimiter = $("input[name='Delimiter']").val();
    var applySeverityFilter = $("input[name='ApplySeverityFilter']").val();
    var calculateSeverityBasedOnCvssV3 = $("input[name='CalculateSeverityBasedOnCvssV3']").is(':checked');
    var filterDuplicateVulnerabilities = $("input[name='FilterDuplicateVulnerabilities']").is(':checked');
    var includeInformationalSeverities = $("input[name='IncludeInformationalSeverities']").is(':checked');
    var includeLowSeverities = $("input[name='IncludeLowSeverities']").is(':checked');
    var includeMediumSeverities = $("input[name='IncludeMediumSeverities']").is(':checked');
    var includeHighSeverities = $("input[name='IncludeHighSeverities']").is(':checked');
    var includeCriticalSeverities = $("input[name='IncludeCriticalSeverities']").is(':checked');

    $(document.getElementById("progressStatus")).removeClass("d-none");
    $(document.getElementById("UploadBtn")).addClass("disabled");   
    $(document.getElementById("actionSuccessful")).addClass("d-none");
    $(document.getElementById("actionFailed")).addClass("d-none");

    for (var i = 0; i != files.length; i++) {
        formData.append("files", files[i]);
    }
    formData.append("delimiter", delimiter);
    formData.append("calculateSeverityBasedOnCvssV3", calculateSeverityBasedOnCvssV3);
    formData.append("applySeverityFilter", applySeverityFilter);
    formData.append("filterDuplicateVulnerabilities", filterDuplicateVulnerabilities);
    formData.append("includeInformationalSeverities", includeInformationalSeverities);
    formData.append("includeLowSeverities", includeLowSeverities);
    formData.append("includeMediumSeverities", includeMediumSeverities);
    formData.append("includeHighSeverities", includeHighSeverities);
    formData.append("includeCriticalSeverities", includeCriticalSeverities);

    $.ajax(
        {
            url: "",
            headers:
            {
                "RequestVerificationToken": t
            },
            data: formData,
            processData: false,
            contentType: false,
            type: "POST",
            success: function (data) {
                $(document.getElementById("progressStatus")).addClass("d-none");
                $(document.getElementById("UploadBtn")).removeClass("disabled");
                console.log(data);

                if (data.actionSuccessful == true) {
                    $(document.getElementById("actionSuccessful")).html(data.resultMessage);
                    $(document.getElementById("actionSuccessful")).removeClass("d-none");

                }
                else {
                    $(document.getElementById("actionFailed")).html(data.resultMessage);
                    $(document.getElementById("actionFailed")).removeClass("d-none");
                }
            }
        }
    );

    $(document.getElementById("UploadBtn")).addClass("disabled");
}